(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('tscommons-core'), require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-adamantinecommons-core', ['exports', 'tscommons-core', '@angular/core', '@angular/common'], factory) :
    (global = global || self, factory(global['ngx-adamantinecommons-core'] = {}, global.tscommonsCore, global.ng.core, global.ng.common));
}(this, function (exports, tscommonsCore, core, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var EAdamantineFieldType = {
        SINGLE: 'single',
        MULTI: 'multi',
        BOOLEAN: 'boolean',
        INTEGER: 'integer',
        FLOAT: 'float',
        DATE: 'date',
        TIME: 'time',
        DATETIME: 'datetime',
        PHONE: 'phone',
        EMAIL: 'email',
        URL: 'url',
        LISTSET: 'listset',
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IAdamantineField() { }
    if (false) {
        /** @type {?} */
        IAdamantineField.prototype.name;
        /** @type {?} */
        IAdamantineField.prototype.description;
        /** @type {?} */
        IAdamantineField.prototype.type;
        /** @type {?|undefined} */
        IAdamantineField.prototype.optional;
        /** @type {?|undefined} */
        IAdamantineField.prototype.allow_multiple;
        /** @type {?|undefined} */
        IAdamantineField.prototype.listset;
    }
    /**
     * @param {?} test
     * @param {?=} ignoreListItems
     * @return {?}
     */
    function isIAdamantineField(test, ignoreListItems) {
        if (ignoreListItems === void 0) { ignoreListItems = false; }
        if (!tscommonsCore.CommonsType.isObject(test))
            return false;
        if (!tscommonsCore.CommonsType.hasPropertyString(test, 'name'))
            return false;
        if (!tscommonsCore.CommonsType.hasPropertyString(test, 'description'))
            return false;
        if (!tscommonsCore.CommonsType.hasPropertyString(test, 'type'))
            return false;
        if (!tscommonsCore.CommonsType.hasPropertyBooleanOrUndefined(test, 'optional'))
            return false;
        if (test.type === EAdamantineFieldType.LISTSET) {
            if (!ignoreListItems)
                if (!tscommonsCore.CommonsType.hasProperty(test, 'listset') || !tscommonsCore.CommonsType.isStringArray(test.listset))
                    return false;
            if (!tscommonsCore.CommonsType.hasPropertyBoolean(test, 'allow_multiple'))
                return false;
        }
        return true;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxAdamantineCommonsCoreModule = /** @class */ (function () {
        function NgxAdamantineCommonsCoreModule() {
        }
        NgxAdamantineCommonsCoreModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule
                        ],
                        declarations: []
                    },] }
        ];
        return NgxAdamantineCommonsCoreModule;
    }());

    exports.EAdamantineFieldType = EAdamantineFieldType;
    exports.NgxAdamantineCommonsCoreModule = NgxAdamantineCommonsCoreModule;
    exports.isIAdamantineField = isIAdamantineField;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-adamantinecommons-core.umd.js.map
